## ros-rolling-rosbag2-transport 0.13.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rosbag2_transport)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# Windows supplies macros for min and max by default. We should only use min and max from stl
if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(keyboard_handler REQUIRED)
find_package(rcl REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rosbag2_compression REQUIRED)
find_package(rosbag2_cpp REQUIRED)
find_package(rosbag2_interfaces REQUIRED)
find_package(rosbag2_storage REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)
find_package(shared_queues_vendor REQUIRED)
find_package(yaml_cpp_vendor REQUIRED)

add_library(${PROJECT_NAME} SHARED
  src/rosbag2_transport/bag_rewrite.cpp
  src/rosbag2_transport/player.cpp
  src/rosbag2_transport/qos.cpp
  src/rosbag2_transport/reader_writer_factory.cpp
  src/rosbag2_transport/recorder.cpp
  src/rosbag2_transport/record_options.cpp
  src/rosbag2_transport/topic_filter.cpp)
target_include_directories(${PROJECT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(${PROJECT_NAME}
  keyboard_handler
  rcl
  rclcpp
  rcutils
  rmw
  rosbag2_compression
  rosbag2_cpp
  rosbag2_interfaces
  rosbag2_storage
  shared_queues_vendor
  yaml_cpp_vendor
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "ROSBAG2_TRANSPORT_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS ${PROJECT_NAME}
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(export_${PROJECT_NAME})
ament_export_dependencies(
  keyboard_handler
  rosbag2_cpp
  rosbag2_compression
  rosbag2_interfaces
  shared_queues_vendor
  yaml_cpp_vendor)

function(create_tests_for_rmw_implementation)
  # disable the following tests for connext
  # due to slower discovery of nodes
  set(SKIP_TEST "")
  if(${rmw_implementation} MATCHES "rmw_connext(.*)")
    set(SKIP_TEST "SKIP_TEST")
  endif()

  rosbag2_transport_add_gmock(test_play
    test/rosbag2_transport/test_play.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_play_loop
    test/rosbag2_transport/test_play_loop.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_play_publish_clock
    test/rosbag2_transport/test_play_publish_clock.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_play_timing
    test/rosbag2_transport/test_play_timing.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_play_seek
    test/rosbag2_transport/test_play_seek.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_play_services
    test/rosbag2_transport/test_play_services.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_play_topic_remap
    test/rosbag2_transport/test_play_topic_remap.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_play_next
      test/rosbag2_transport/test_play_next.cpp
      INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>
      LINK_LIBS rosbag2_transport
      AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_qos
    test/rosbag2_transport/test_qos.cpp
    INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    LINK_LIBS rosbag2_transport
    AMENT_DEPS rosbag2_test_common yaml_cpp_vendor)

  rosbag2_transport_add_gmock(test_record
    test/rosbag2_transport/test_record.cpp
    INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_record_all
    test/rosbag2_transport/test_record_all.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_record_all_ignore_leaf_topics
    test/rosbag2_transport/test_record_all_ignore_leaf_topics.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_record_all_no_discovery
    test/rosbag2_transport/test_record_all_no_discovery.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_keyboard_controls
    test/rosbag2_transport/test_keyboard_controls.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

  rosbag2_transport_add_gmock(test_record_regex
    test/rosbag2_transport/test_record_regex.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common
    ${SKIP_TEST})

  rosbag2_transport_add_gmock(test_record_services
    test/rosbag2_transport/test_record_services.cpp
    LINK_LIBS rosbag2_transport
    AMENT_DEPS test_msgs rosbag2_test_common)

endfunction()

if(BUILD_TESTING)
  add_definitions(-D_SRC_RESOURCES_DIR_PATH="${CMAKE_CURRENT_SOURCE_DIR}/test/resources")

  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_index_cpp REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(test_msgs REQUIRED)
  find_package(rosbag2_test_common REQUIRED)
  include(cmake/rosbag2_transport_add_gmock.cmake)
  ament_lint_auto_find_test_dependencies()
  call_for_each_rmw_implementation(create_tests_for_rmw_implementation)

  ament_add_gmock(test_record_options
    test/rosbag2_transport/test_record_options.cpp)
  target_include_directories(test_record_options PRIVATE include)
  target_link_libraries(test_record_options ${PROJECT_NAME})

  ament_add_gmock(test_topic_filter
    test/rosbag2_transport/test_topic_filter.cpp)
  target_include_directories(test_topic_filter PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>)
  target_link_libraries(test_topic_filter rosbag2_transport)

  ament_add_gmock(test_rewrite
    test/rosbag2_transport/test_rewrite.cpp)
  target_include_directories(test_rewrite PRIVATE include)
  target_link_libraries(test_rewrite ${PROJECT_NAME})
  ament_target_dependencies(test_rewrite keyboard_handler rcpputils rosbag2_cpp test_msgs)
endif()

ament_package()

=== debian/changelog ===
ros-rolling-rosbag2-transport (0.13.0-1focal) focal; urgency=high



 -- Geoffrey Biggs <geoff@openrobotics.org>  Thu, 13 Jan 2022 08:00:00 -0000

ros-rolling-rosbag2-transport (0.12.0-1focal) focal; urgency=high

  * Changes for uncrustify 0.72 (#937 <https://github.com/ros2/rosbag2/issues/937>)
  * TopicFilter use regex_search instead of regex_match (#932 <https://github.com/ros2/rosbag2/issues/932>)
  * Add start-offset play option (#931 <https://github.com/ros2/rosbag2/issues/931>)
  * Add parentheses suggested by Clang on OSX to fix build warning (#930 <https://github.com/ros2/rosbag2/issues/930>)
  * Bag rewriter (C++) (#920 <https://github.com/ros2/rosbag2/issues/920>)
  * Add "ignore leaf topics" option to recorder (#925 <https://github.com/ros2/rosbag2/issues/925>)
  * Rewrite TopicFilter for single-call reusability (#924 <https://github.com/ros2/rosbag2/issues/924>)
  * Add a ReaderWriterFactory utility to share logic for reuse (#923 <https://github.com/ros2/rosbag2/issues/923>)
  * Add pause/resume options to the bag recorder (#905 <https://github.com/ros2/rosbag2/issues/905>)
  * Add logging macros for rosbag2_transport (#917 <https://github.com/ros2/rosbag2/issues/917>)
  * Enable YAML encoding/decoding for RecordOptions and StorageOptions (#916 <https://github.com/ros2/rosbag2/issues/916>)
  * Expose the QoS object wrapper (#910 <https://github.com/ros2/rosbag2/issues/910>)
  * Contributors: Abrar Rahman Protyasha, Chris Lalancette, Emerson Knapp, Geoffrey Biggs, Ivan Santiago Paunovic

 -- Geoffrey Biggs <geoff@openrobotics.org>  Fri, 17 Dec 2021 08:00:00 -0000

ros-rolling-rosbag2-transport (0.11.0-1focal) focal; urgency=high

  * Add --start-paused option to ros2 bag play (#904 <https://github.com/ros2/rosbag2/issues/904>)
  * Update package maintainers (#899 <https://github.com/ros2/rosbag2/issues/899>)
  * Add a Seek service (#874 <https://github.com/ros2/rosbag2/issues/874>)
  * Add simple keyboard control for playback rate (#893 <https://github.com/ros2/rosbag2/issues/893>)
  * Contributors: Emerson Knapp, Ivan Santiago Paunovic, Michel Hidalgo

 -- Geoffrey Biggs <geoff@openrobotics.org>  Mon, 08 Nov 2021 08:00:00 -0000

ros-rolling-rosbag2-transport (0.10.1-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Fri, 22 Oct 2021 07:00:00 -0000

ros-rolling-rosbag2-transport (0.10.0-1focal) focal; urgency=high

  * Fix a bug on invalid pointer address when using "MESSAGE" compressio… (#866 <https://github.com/ros2/rosbag2/issues/866>)
  * Fix typo (#880 <https://github.com/ros2/rosbag2/issues/880>)
  * Use Reader's seek() method for seeking/jumping in Player (#873 <https://github.com/ros2/rosbag2/issues/873>)
  * keyboard controls for pause/resume toggle and play-next: (#847 <https://github.com/ros2/rosbag2/issues/847>)
  * Implement snapshot mechanism and corresponding ROS Service (#850 <https://github.com/ros2/rosbag2/issues/850>)
  * Circular Message Cache implementation for snapshot feature (#844 <https://github.com/ros2/rosbag2/issues/844>)
  * Add jump/seek API for Player class (#826 <https://github.com/ros2/rosbag2/issues/826>)
  * Restructure test_play_timing to one test per case, to see which times out (#863 <https://github.com/ros2/rosbag2/issues/863>)
  * Fix discovery silently stops after unknown msg type is found. (#848 <https://github.com/ros2/rosbag2/issues/848>)
  * Fixing deprecated subscriber callback warnings (#852 <https://github.com/ros2/rosbag2/issues/852>)
  * Bugfix for race condition in Player::peek_next_message_from_queue() (#849 <https://github.com/ros2/rosbag2/issues/849>)
  * added seek interface (#836 <https://github.com/ros2/rosbag2/issues/836>)
  * Update PlayOptions::delay to rclcpp::Duration to get nanosecond resolution (#843 <https://github.com/ros2/rosbag2/issues/843>)
  * Move notification about ready for playback inside play_messages_from_queue() (#832 <https://github.com/ros2/rosbag2/issues/832>)
  * Add wait for player to be ready for playback in Player::play_next() method (#814 <https://github.com/ros2/rosbag2/issues/814>)
  * Make sure the subscription exists before publishing messages (#804 <https://github.com/ros2/rosbag2/issues/804>)
  * Add delay option (#789 <https://github.com/ros2/rosbag2/issues/789>)
  * Copy recorder QoS profile to local variable so that temporary value isn't cleared (#803 <https://github.com/ros2/rosbag2/issues/803>)
  * test_play_services: fail gracefully on future error (#798 <https://github.com/ros2/rosbag2/issues/798>)
  * Recording with --all and --exclude fix (#765 <https://github.com/ros2/rosbag2/issues/765>)
  * Contributors: Abrar Rahman Protyasha, Barry Xu, Bastian Jäger, Cameron Miller, Emerson Knapp, Kosuke Takeuchi, Lei Liu, Louise Poubel, Michael Orlov, Piotr Jaroszek, sonia

 -- Karsten Knese <karsten@openrobotics.org>  Tue, 19 Oct 2021 07:00:00 -0000

ros-rolling-rosbag2-transport (0.9.0-1focal) focal; urgency=high

  * Expose play_next service (#767 <https://github.com/ros2/rosbag2/issues/767>)
  * Add play_next() API to the player class (#762 <https://github.com/ros2/rosbag2/issues/762>)
  * Naive clock jump implementation - allows for clock reuse and simplified Player setup (#754 <https://github.com/ros2/rosbag2/issues/754>)
  * Rename Reader/Writer 'reset' to 'close' (#760 <https://github.com/ros2/rosbag2/issues/760>)
  * simply constructor for rosbag2_transport::Player (#757 <https://github.com/ros2/rosbag2/issues/757>)
  * Expose GetRate/SetRate services for playback (#753 <https://github.com/ros2/rosbag2/issues/753>)
  * Expose pause/resume related services on the Player (#729 <https://github.com/ros2/rosbag2/issues/729>)
  * remodel publication manager (#749 <https://github.com/ros2/rosbag2/issues/749>)
  * remove rosbag2_transport header (#742 <https://github.com/ros2/rosbag2/issues/742>)
  * use public recorder api in tests (#741 <https://github.com/ros2/rosbag2/issues/741>)


=== debian/control ===
Source: ros-rolling-rosbag2-transport
Section: misc
Priority: optional
Maintainer: Geoffrey Biggs <geoff@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-gmock, ros-rolling-ament-cmake-ros, ros-rolling-ament-index-cpp, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-keyboard-handler, ros-rolling-rclcpp, ros-rolling-rmw, ros-rolling-rmw-implementation-cmake, ros-rolling-rosbag2-compression, ros-rolling-rosbag2-compression-zstd, ros-rolling-rosbag2-cpp, ros-rolling-rosbag2-interfaces, ros-rolling-rosbag2-storage, ros-rolling-rosbag2-test-common, ros-rolling-shared-queues-vendor, ros-rolling-test-msgs, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rosbag2-transport
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-keyboard-handler, ros-rolling-rclcpp, ros-rolling-rmw, ros-rolling-rosbag2-compression, ros-rolling-rosbag2-cpp, ros-rolling-rosbag2-interfaces, ros-rolling-rosbag2-storage, ros-rolling-shared-queues-vendor, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Description: Layer encapsulating ROS middleware to allow rosbag2 to be used with or without middleware

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rosbag2-transport//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rosbag2-transport 0.24.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,19 @@
   set(CMAKE_C_STANDARD 99)
 endif()
 
-# Default to C++14
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD 17)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   add_compile_options(-Wall -Wextra -Wpedantic)
+endif()
+if(CMAKE_BUILD_TYPE STREQUAL "Debug" AND MSVC)
+  # /bigobj is needed to avoid error C1128:
+  #   https://msdn.microsoft.com/en-us/library/8578y171.aspx
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
 endif()
 
 # Windows supplies macros for min and max by default. We should only use min and max from stl
@@ -45,19 +51,20 @@
   src/rosbag2_transport/topic_filter.cpp)
 target_include_directories(${PROJECT_NAME} PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-  $<INSTALL_INTERFACE:include>)
-ament_target_dependencies(${PROJECT_NAME}
-  keyboard_handler
-  rcl
-  rclcpp
-  rcutils
-  rmw
-  rosbag2_compression
-  rosbag2_cpp
-  rosbag2_interfaces
-  rosbag2_storage
-  shared_queues_vendor
-  yaml_cpp_vendor
+  $<INSTALL_INTERFACE:include/${PROJECT_NAME}>)
+target_link_libraries(${PROJECT_NAME}
+  keyboard_handler::keyboard_handler
+  rcl::rcl
+  rclcpp::rclcpp
+  rcutils::rcutils
+  rmw::rmw
+  rosbag2_compression::rosbag2_compression
+  rosbag2_cpp::rosbag2_cpp
+  ${rosbag2_interfaces_TARGETS}
+  rosbag2_storage::rosbag2_storage
+  shared_queues_vendor::singleproducerconsumer
+  shared_queues_vendor::concurrentqueue
+  yaml-cpp
 )
 
 # Causes the visibility macros to use dllexport rather than dllimport,
@@ -66,7 +73,7 @@
 
 install(
   DIRECTORY include/
-  DESTINATION include
+  DESTINATION include/${PROJECT_NAME}
 )
 install(
   TARGETS ${PROJECT_NAME}
@@ -76,9 +83,13 @@
   RUNTIME DESTINATION bin
 )
 
-ament_export_include_directories(include)
+# Export old-style CMake variables
+ament_export_include_directories("include/${PROJECT_NAME}")
 ament_export_libraries(${PROJECT_NAME})
+
+# Export modern CMake targets
 ament_export_targets(export_${PROJECT_NAME})
+
 ament_export_dependencies(
   keyboard_handler
   rosbag2_cpp
@@ -118,6 +129,16 @@
     LINK_LIBS rosbag2_transport
     AMENT_DEPS test_msgs rosbag2_test_common)
 
+  rosbag2_transport_add_gmock(test_play_callbacks
+    test/rosbag2_transport/test_play_callbacks.cpp
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
+  rosbag2_transport_add_gmock(test_player_stop
+    test/rosbag2_transport/test_player_stop.cpp
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
   rosbag2_transport_add_gmock(test_play_seek
     test/rosbag2_transport/test_play_seek.cpp
     LINK_LIBS rosbag2_transport
@@ -133,6 +154,12 @@
     LINK_LIBS rosbag2_transport
     AMENT_DEPS test_msgs rosbag2_test_common
     ${SKIP_TEST})
+
+  rosbag2_transport_add_gmock(test_play_duration
+      test/rosbag2_transport/test_play_duration.cpp
+      INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>
+      LINK_LIBS rosbag2_transport
+      AMENT_DEPS test_msgs rosbag2_test_common)
 
   rosbag2_transport_add_gmock(test_play_next
       test/rosbag2_transport/test_play_next.cpp
@@ -140,6 +167,18 @@
       LINK_LIBS rosbag2_transport
       AMENT_DEPS test_msgs rosbag2_test_common)
 
+  rosbag2_transport_add_gmock(test_play_until
+      test/rosbag2_transport/test_play_until.cpp
+      INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>
+      LINK_LIBS rosbag2_transport
+      AMENT_DEPS test_msgs rosbag2_test_common)
+
+  rosbag2_transport_add_gmock(test_burst
+    test/rosbag2_transport/test_burst.cpp
+    INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
   rosbag2_transport_add_gmock(test_qos
     test/rosbag2_transport/test_qos.cpp
     INCLUDE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
@@ -163,11 +202,21 @@
     LINK_LIBS rosbag2_transport
     AMENT_DEPS test_msgs rosbag2_test_common)
 
+  rosbag2_transport_add_gmock(test_record_all_include_unpublished_topics
+    test/rosbag2_transport/test_record_all_include_unpublished_topics.cpp
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
   rosbag2_transport_add_gmock(test_record_all_no_discovery
     test/rosbag2_transport/test_record_all_no_discovery.cpp
     LINK_LIBS rosbag2_transport
     AMENT_DEPS test_msgs rosbag2_test_common)
 
+  rosbag2_transport_add_gmock(test_record_all_use_sim_time
+    test/rosbag2_transport/test_record_all_use_sim_time.cpp
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
   rosbag2_transport_add_gmock(test_keyboard_controls
     test/rosbag2_transport/test_keyboard_controls.cpp
     LINK_LIBS rosbag2_transport
@@ -184,6 +233,18 @@
     LINK_LIBS rosbag2_transport
     AMENT_DEPS test_msgs rosbag2_test_common)
 
+  rosbag2_transport_add_gmock(test_component_parameters
+      test/rosbag2_transport/test_composable_recorder.cpp
+    LINK_LIBS rosbag2_transport
+    AMENT_DEPS test_msgs rosbag2_test_common)
+
+  if(${rmw_implementation} MATCHES "rmw_cyclonedds(.*)")
+    ament_add_test_label(test_play_services__rmw_cyclonedds_cpp xfail)
+  endif()
+
+  if(${rmw_implementation} MATCHES "rmw_fastrtps(.*)")
+    ament_add_test_label(test_play_services__rmw_fastrtps_cpp xfail)
+  endif()
 endfunction()
 
 if(BUILD_TESTING)
@@ -200,20 +261,30 @@
 
   ament_add_gmock(test_record_options
     test/rosbag2_transport/test_record_options.cpp)
-  target_include_directories(test_record_options PRIVATE include)
   target_link_libraries(test_record_options ${PROJECT_NAME})
+
+  ament_add_gmock(test_type_description_hash
+    test/rosbag2_transport/test_type_description_hash.cpp)
+  target_link_libraries(test_type_description_hash ${PROJECT_NAME})
 
   ament_add_gmock(test_topic_filter
     test/rosbag2_transport/test_topic_filter.cpp)
   target_include_directories(test_topic_filter PRIVATE
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/rosbag2_transport>)
-  target_link_libraries(test_topic_filter rosbag2_transport)
+  target_link_libraries(test_topic_filter
+    ${PROJECT_NAME}
+  )
 
   ament_add_gmock(test_rewrite
     test/rosbag2_transport/test_rewrite.cpp)
-  target_include_directories(test_rewrite PRIVATE include)
-  target_link_libraries(test_rewrite ${PROJECT_NAME})
-  ament_target_dependencies(test_rewrite keyboard_handler rcpputils rosbag2_cpp test_msgs)
+  target_link_libraries(test_rewrite
+    ${PROJECT_NAME}
+    keyboard_handler::keyboard_handler
+    rcpputils::rcpputils
+    rosbag2_cpp::rosbag2_cpp
+    rosbag2_test_common::rosbag2_test_common
+    ${test_msgs_TARGTES}
+  )
 endif()
 
 ament_package()

=== debian/changelog ===
ros-rolling-rosbag2-transport (0.24.0-1jammy) jammy; urgency=high

  * Fix for rosbag2_transport::Recorder failures due to the unhandled exceptions (#1382 <https://github.com/ros2/rosbag2/issues/1382>)
  * When using sim time, wait for /clock before beginning recording (#1378 <https://github.com/ros2/rosbag2/issues/1378>)
  * Fix for possible freeze in Recorder::stop() (#1381 <https://github.com/ros2/rosbag2/issues/1381>)
  * Revert "Don't record sim-time messages before first /clock (#1354 <https://github.com/ros2/rosbag2/issues/1354>)" (#1377 <https://github.com/ros2/rosbag2/issues/1377>)
  * Don't record sim-time messages before first /clock (#1354 <https://github.com/ros2/rosbag2/issues/1354>)
  * Fix a clang warning about uninitialized variable. (#1370 <https://github.com/ros2/rosbag2/issues/1370>)
  * [bugfix] for parameters not passing to recorder's node from child component (#1360 <https://github.com/ros2/rosbag2/issues/1360>)
  * Change subscriptions from GenericSubscripton to SubscriptionBase (#1337 <https://github.com/ros2/rosbag2/issues/1337>)
  * Add recorder stop() API (#1300 <https://github.com/ros2/rosbag2/issues/1300>)
  * Contributors: Chris Lalancette, Emerson Knapp, Michael Orlov, Patrick Roncagliolo

 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.23.0-1jammy) jammy; urgency=high



 -- Michael Orlov <michael.orlov@apex.ai>  Fri, 28 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.22.0-1jammy) jammy; urgency=high

  * Read message definitions from input files in bag_rewrite (#1295 <https://github.com/ros2/rosbag2/issues/1295>)
  * Add message definition read API (#1292 <https://github.com/ros2/rosbag2/issues/1292>)
  * Move rosbag2_transport::Recorder implementation to pimpl (#1291 <https://github.com/ros2/rosbag2/issues/1291>)
  * rosbag2_storage: add type description hash to topic metadata (#1272 <https://github.com/ros2/rosbag2/issues/1272>)
  * Contributors: Emerson Knapp, Michael Orlov, james-rms

 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 18 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.21.0-1jammy) jammy; urgency=high

  * rosbag2_cpp: move local message definition source out of MCAP plugin (#1265 <https://github.com/ros2/rosbag2/issues/1265>)
  * Use RMW methods to initialize endpoint info instead of brace initializer to guard against upcoming struct change (#1257 <https://github.com/ros2/rosbag2/issues/1257>)
  * Update rosbag2 to C++17. (#1238 <https://github.com/ros2/rosbag2/issues/1238>)
  * Use target_link_libraries instead of ament_target_dependencies (#1202 <https://github.com/ros2/rosbag2/issues/1202>)
  * Contributors: Chris Lalancette, Daisuke Nishimatsu, Emerson Knapp, Michael Orlov, james-rms

 -- Michael Orlov <michael.orlov@apex.ai>  Wed, 12 Apr 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.20.0-1jammy) jammy; urgency=high



 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 14 Feb 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.19.0-1jammy) jammy; urgency=high

  * Print "Hidden topics are not recorded" only once. (#1225 <https://github.com/ros2/rosbag2/issues/1225>)
  * rosbag2_storage: set MCAP as default plugin (#1160 <https://github.com/ros2/rosbag2/issues/1160>)
  * Add Michael Orlov as maintainer in rosbag2 packages (#1215 <https://github.com/ros2/rosbag2/issues/1215>)
  * rosbag2_transport: parametrize test_rewrite (#1206 <https://github.com/ros2/rosbag2/issues/1206>)
  * rosbag2_cpp: test more than one storage plugin (#1196 <https://github.com/ros2/rosbag2/issues/1196>)
  * Replace language for "db3"/"db"/"database" (#1194 <https://github.com/ros2/rosbag2/issues/1194>)
  * set_read_order: return success (#1177 <https://github.com/ros2/rosbag2/issues/1177>)
  * Remove explicit sqlite3 from code (#1166 <https://github.com/ros2/rosbag2/issues/1166>)
  * Contributors: Emerson Knapp, Michael Orlov, james-rms, rshanor

 -- Michael Orlov <michael.orlov@apex.ai>  Fri, 13 Jan 2023 00:00:00 -0000

ros-rolling-rosbag2-transport (0.18.0-1jammy) jammy; urgency=high

  * Add pause and resume service calls for rosbag2 recorder (#1131 <https://github.com/ros2/rosbag2/issues/1131>)
  * Redesign record_services tests to make them more deterministic (#1122 <https://github.com/ros2/rosbag2/issues/1122>)
  * Add SplitBagfile recording service. (#1115 <https://github.com/ros2/rosbag2/issues/1115>)
  * Reverse read order API and sqlite storage implementation (#1083 <https://github.com/ros2/rosbag2/issues/1083>)
  * make recorder node composable by inheritance (#1093 <https://github.com/ros2/rosbag2/issues/1093>)
  * Mark test_play_services as xfail for FastRTPS and CycloneDDS (#1091 <https://github.com/ros2/rosbag2/issues/1091>)
  * fixed typo (#1057 <https://github.com/ros2/rosbag2/issues/1057>)
  * Fix hangout in rosbag2 player and recorder when pressing CTRL+C (#1081 <https://github.com/ros2/rosbag2/issues/1081>)
  * Added support for excluding topics via regular expressions (#1046 <https://github.com/ros2/rosbag2/issues/1046>)
  * Contributors: Bernardo Taveira, Cristóbal Arroyo, DensoADAS, Emerson Knapp, Esteve Fernandez, Michael Orlov, rshanor

 -- Michael Orlov <michael.orlov@apex.ai>  Tue, 15 Nov 2022 00:00:00 -0000

ros-rolling-rosbag2-transport (0.17.0-1jammy) jammy; urgency=high

  * Use a single variable for evaluating the filter regex (#1053 <https://github.com/ros2/rosbag2/issues/1053>)
  * Add additional mode of publishing sim time updates triggered by replayed messages (#1050 <https://github.com/ros2/rosbag2/issues/1050>)
  * Speed optimization: Preparing copyless publish/subscribing by using const message for writing (#1010 <https://github.com/ros2/rosbag2/issues/1010>)
  * Renamed --topics-regex to --regex and -e in Player class to be consistent with Recorder (#1045 <https://github.com/ros2/rosbag2/issues/1045>)
  * Refactor play until and duration tests (#1024 <https://github.com/ros2/rosbag2/issues/1024>)


=== debian/control ===
Source: ros-rolling-rosbag2-transport
Section: misc
Priority: optional
Maintainer: Michael Orlov <michael.orlov@apex.ai>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-gmock <!nocheck>, ros-rolling-ament-cmake-ros, ros-rolling-ament-index-cpp <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-keyboard-handler, ros-rolling-rclcpp, ros-rolling-rmw, ros-rolling-rmw-implementation-cmake <!nocheck>, ros-rolling-rosbag2-compression, ros-rolling-rosbag2-compression-zstd <!nocheck>, ros-rolling-rosbag2-cpp, ros-rolling-rosbag2-interfaces, ros-rolling-rosbag2-storage, ros-rolling-rosbag2-storage-default-plugins <!nocheck>, ros-rolling-rosbag2-test-common <!nocheck>, ros-rolling-shared-queues-vendor, ros-rolling-test-msgs <!nocheck>, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rosbag2-transport
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-keyboard-handler, ros-rolling-rclcpp, ros-rolling-rmw, ros-rolling-rosbag2-compression, ros-rolling-rosbag2-cpp, ros-rolling-rosbag2-interfaces, ros-rolling-rosbag2-storage, ros-rolling-shared-queues-vendor, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Description: Layer encapsulating ROS middleware to allow rosbag2 to be used with or without middleware

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
